// nach: Abts, Grundkurs Java, Wiesbanden, 2003
// verändert und angepasst: Prof. Dr. M. Scheer, FH-Gießen-Friedberg

import java.text.* ;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.sql.*;
import javax.swing.table.*;

public class GUI extends JPanel implements ActionListener, ListSelectionListener {
   private String tabellenName = "unbekannt" ;

   private JTable table = new JTable();
   private JTextField artikelTab = new JTextField(15);
   private JTextField msg = new JTextField(30);
   private JButton b1 = new JButton("Tabelle einlesen");

   private Statement anw = null ;
   private String sql = "" ;

   public GUI(Statement anw) {
      this.anw = anw ;

      msg.setEditable(false);
      setLayout(new BorderLayout(5, 5));
      artikelTab.setText(tabellenName) ;

      JPanel p1 = new JPanel();
      p1.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
      b1.addActionListener(this);
      b1.setActionCommand("b1");
      p1.add(b1);

      JPanel p2 = new JPanel();
      p2.setLayout(new FlowLayout(FlowLayout.CENTER));
      p2.add(new JScrollPane(table));

      JPanel p3 = new JPanel();
      p3.setLayout(new FlowLayout(FlowLayout.CENTER));
      p3.add(new JLabel("Meldungen:"));
      p3.add(msg);

      JPanel p5 = new JPanel() ;
      p5.setLayout(new BorderLayout(5, 5));
      p5.add(p2, BorderLayout.NORTH);
      p5.add(p3, BorderLayout.SOUTH);


      JPanel p4 = new JPanel();
      p4.setLayout(new FlowLayout());
      p4.add(new JLabel("Artikel-Tabelle eingeben: "));
      p4.add(artikelTab);
      
      add(p4, BorderLayout.NORTH);
      add(p5, BorderLayout.CENTER);
      add(p1, BorderLayout.SOUTH);
   }

   // ListSelection-Listener für das Markieren der Tabelle
   public void valueChanged(ListSelectionEvent e) {
      int row = table.getSelectedRow();

      System.out.println("Selektierte Zeile: " + row);
   }

   // Listener für die Buttons
   public void actionPerformed(ActionEvent e) {
      String cmd = e.getActionCommand();
      tabellenName = artikelTab.getText();

      if (cmd.equals("b1")) tabelleLesen();
   }

   // Methoden des Action-Listeners
   private void tabelleLesen() {
      String[] spalten = {"ID", "Bezeichnung", "Gültigkeitsdatum", "Preis"};
      String[][] daten ;
      int zeilen = 0 ;
      TabellenModell tabMod ;

      //Listener für das Selektieren einer Tabellenzeile registrieren
      table.getSelectionModel().addListSelectionListener(this);
      msg.setText(" ");

      // Methode hier ergänzen:
      // 1) Artikeldaten einlesen,
      // 2) Anzahl Zeilen bestimmen,
      // 3) String-Array entsprechend der Anzahl Zeilen/Spalten instanziieren
      // 4) Artikeldaten in das String-Array übertragen










      // 5) TableModel instanziieren, Daten an den Konstruktor übergeben
      tabMod = new TabellenModell(daten, spalten) ;
      // 6) TableModel dem JTable-View bekannt machen
      table.setModel(tabMod);
      // 7) Aktualisierung des Views beim TableModel anstoßen
      tabMod.fireTableDataChanged();
   }
}