import javax.swing.*;
import java.util.*;
import java.io.*;
import java.lang.reflect.*;

public class TestReflection {

   public static void main(String[] args) {
      String s ;
      TestReflection test = new TestReflection() ;
      
//      JButton b = new JButton("ja");
//      test.druckeKlassenName(b);

//      test.druckeModifizierer(b);

//      Weitere Methodenaufrufe siehe weiter unten!

//      Sie können eine Instanz bilden und diese den Methoden übergeben
//      (siehe oben). Eine andere Möglichkeit wäre, die Klassenbeschreibung
//      an die Methoden zu übergeben. Dann würde die Anweisung
//      Class klassenBeschreibung = obj.getClass();
//      in den Methoden entfallen. Die Schnittstellen müssten für ein Objekt der
//      Klasse Class abgeändert werden.
//      
//      Die Klassenbeschreibung erhält man auch, wenn man an den Klassenname
//      .class anfügt, unter der Voraussetzung, die Klasse liegt im selben
//      Verzeichnis wie das Testprogramm.
//      
//      Beispiele: Klasse1.class , Klasse2.class



   }

   public void druckeKlassenName(Object obj) {
      Class klassenBeschreibung = obj.getClass();
      System.out.println("Name der Klasse: " + klassenBeschreibung.getName());
   }

   public void erzeugeUndDruckeNamen(String s) {
      try {
         Class klassenBeschreibung = Class.forName(s);
         System.out.println("Name der Klasse: " + klassenBeschreibung.getName());
      }
      catch(ClassNotFoundException cnfe) {
         System.out.println("Klasse nicht gefunden!");
      }
   }

   public void druckeModifizierer(Object obj) {
      Class klassenBeschreibung = obj.getClass();
      int m = klassenBeschreibung.getModifiers() ;
      System.out.println("Modifizierer: " + m);
      
      if (Modifier.isPublic(m)) {
         System.out.println("Modifizierer: public" );
      }

      if (Modifier.isPrivate(m)) {
         System.out.println("Modifizierer: private" );
      }
   }

   public void druckeSuperklasse(Object obj) {
      Class klassenBeschreibung = obj.getClass();
      Class dieOberklasse = klassenBeschreibung.getSuperclass();

      String className = dieOberklasse.getName();
      System.out.println(className);
   }
   
   public void druckeInterfaceNamen(Object obj) {
      Class klassenBeschreibung = obj.getClass();
      Class[] dieInterfaces = klassenBeschreibung.getInterfaces();
      
      if (dieInterfaces.length == 0) System.out.println("Keine Interfaces gefunden");

      for (int i = 0; i < dieInterfaces.length; ++i) {
         String interfaceName = dieInterfaces[i].getName();
         System.out.println(interfaceName);
      }
   }

   public void druckeFeldNamen(Object obj) {
      Class klassenBeschreibung = obj.getClass();
      Field[] publicFields = klassenBeschreibung.getFields();

      if (publicFields.length == 0) System.out.println("Keine Fields gefunden");

      for (int i = 0; i < publicFields.length; ++i) {
         String fieldName = publicFields[i].getName();
         Class typeClass = publicFields[i].getType();
         String fieldType = typeClass.getName();
         System.out.println("Name: " + fieldName + ", Type: " + fieldType);
      }
   }
   
   public void zeigeKonstruktoren(Object obj) {
      Class klassenBeschreibung = obj.getClass();
      Constructor[] dieKonstruktoren = klassenBeschreibung.getConstructors();

      if (dieKonstruktoren.length == 0) System.out.println("Keine Konstruktoren gefunden");

      for (int i = 0; i < dieKonstruktoren.length; ++i) {
         System.out.print("( ");
         Class[] parameterTypen = dieKonstruktoren[i].getParameterTypes();

         for (int k = 0; k < parameterTypen.length; ++k) {
            String parameterString = parameterTypen[k].getName();
            System.out.print(parameterString + " ");
         }
         System.out.println(")");
      }
   }

   public void zeigeMethoden(Object obj) {
      Class klassenBeschreibung = obj.getClass();
      Method[] dieMethoden = klassenBeschreibung.getMethods();

      if (dieMethoden.length == 0) System.out.println("Keine Methoden gefunden");

      for (int i = 0; i < dieMethoden.length; ++i) {
         String methodenName = dieMethoden[i].getName();
         System.out.println("Name: " + methodenName);
         String returnTyp = dieMethoden[i].getReturnType().getName();
         System.out.println("   Return Type: " + returnTyp);
         Class[] parameterTypes = dieMethoden[i].getParameterTypes();
         System.out.print("   Parameter Types:");

         for (int k = 0; k < parameterTypes.length; ++k) {
            String parameterString = parameterTypes[k].getName();
            System.out.print(" " + parameterString);
         }
         System.out.println();
      }
   }
   
   public Object erzeugeObjekt(String classenName) {
      Object obj = null;

      try {
          Class classenDeskriptor = Class.forName(classenName);
          obj = classenDeskriptor.newInstance();
      }
      catch (ClassNotFoundException e) {
          System.out.println(e);
      }
      catch (InstantiationException e) {
          System.out.println(e);
      }
      catch (IllegalAccessException e) {
          System.out.println(e);
      }

      return obj;
   }

}


