/* EinfacherObjektSpeicher.java */

import java.io.*;
import java.util.*;

/**
 * Trivialer Objektspeicher, der Mengen von Name-Objekt-
 * Paaren aufnehmen und persistent speichern kann.
 * aus: Guido Krüger, Handbuch der Javaprogrammierung, 4. Aufl., 2006.
 *
 * Der eigentliche Speicher besteht aus einer Hashtable. Als Keys benutzen sie
 * String-Objekte, als Werte sind beliebige Objekte zulässig. Die Klasse
 * Hashtable implementiert u.a. das Interface Serializable.
 */
public class EinfacherObjektSpeicher {
   //Instanzvariablen
   private String dateiName;
   private Hashtable objects;

   /**
   * Erzeugt einen neuen Objektspeicher mit dem angegebenen
   * Dateinamen, die Erweiterung ".tos" ("trivial object store")
   * wird ggfs. automatisch angehängt.
   */
   public EinfacherObjektSpeicher(String dateiName) {

      if (!dateiName.endsWith(".tos")) {
         dateiName += ".tos";
      }

      this.dateiName = dateiName;
      this.objects = new Hashtable(50);
   }

   /**
   * Sichert den Objektspeicher unter dem im Konstruktor
   * angegebenen Dateinamen.
   */
   public void save() throws IOException {
      // Methode hier ergänzen


   }

   /**
   * Lädt den Objektspeicher mit dem im Konstruktor
   * angegebenen Namen.
   */
   public void load() throws ClassNotFoundException, IOException {
      // Methode hier ergänzen


   }

   /**
   * Fügt ein Objekt in den Objektspeicher (Hashtable) ein.
   */
   public void putObject(String name, Object object) {
      // Methode hier ergänzen

   }

   /**
   * Liest das Objekt mit dem angegebenen Namen aus dem
   * Objektspeicher. Ist es nicht vorhanden, wird null
   * zurückgegeben.
   */
   public Object getObject(String name) {
      // Methode hier ergänzen
      return null ;
   }
}
