import java.util.*;

public class Laborkurs {
   private String kurs;
   private Vector teilnehmer;
   private int maxTeilnehmer;
    
   /**
    * Erzeuge einen Laborkurs mit einer Teilnehmerbegrenzung:
    * Parameter: Kursname, max. Anzahl Teilnehmer
    */
   public Laborkurs(String neuerKurs, int maxTeilnehmer) {
      kurs = neuerKurs ;
      teilnehmer = new Vector() ;
      this.maxTeilnehmer = maxTeilnehmer ;
   }

   /**
    * Gibt den Kursnamen zurück
    */
   public String kursName() {return kurs ;}
   
   /**
    * Trage einen Teilnehmer in diesen Kurs ein.
    */
   public void trageTeilnehmerEin(Student neuerTeilnehmer) {
      if(anzahlTeilnehmer() == maxTeilnehmer) {
         System.out.println("Der Kurs ist voll, keine Eintragung mehr möglich.");
      }
      else {
         teilnehmer.addElement(neuerTeilnehmer);
         neuerTeilnehmer.trageKursEin(this) ;            // Teilaufgabe e), Kurs beim Teilnehmer eintragen
      }
   }
    
   /**
    * Gibt die aktuelle Teilnehmeranzahl zurück.
    */
   public int anzahlTeilnehmer() { return teilnehmer.size() ; }
    
   // Teilaufgabe d): Lösung mit for-Schleife
   /**
    * Gib eine Liste der Teilnehmer zusammen mit den weiteren Details
    * dieses Kurses auf die Konsole aus (Lösung mit for-Schleife).
    */
   public void listeAusgeben() {
      int i ;
      System.out.println("Laborkurs: " + kurs);
      System.out.println("Teilnehmerliste:");

      for (i = 0; i < teilnehmer.size(); ++i) {
         Student student = (Student) teilnehmer.elementAt(i) ;
         student.ausgeben();
      }

      System.out.println("Teilnehmeranzahl: " + anzahlTeilnehmer());
   }

   // Teilaufgabe f): Lösung mit Iterator
   /**
    * Gib eine Liste der Teilnehmer zusammen mit den weiteren Details
    * dieses Kurses auf die Konsole aus (Lösung mit while-Schleife).
    */
   public void listeAusgeben2() {
      Iterator iterVektor = teilnehmer.iterator() ;
      System.out.println("Laborkurs: " + kurs);
      System.out.println("Teilnehmerliste:");

      while (iterVektor.hasNext()) {
         Student student = (Student) iterVektor.next() ;
         student.ausgeben();
      }

      System.out.println("Teilnehmeranzahl: " + anzahlTeilnehmer());
   }

}
