import java.util.*;                      // Teilaufgabe e), Bibliothek für die Klasse Vector

public class Student {
   // Instanzvariablen
   private String name, vorName;
   private String matrikelNr;
   private int punkte;
   private Vector kurse ;                     // Teilaufgabe e)

   // Konstruktor
   /**
    * Erzeuge ein Objekt für ein Studenten.
    * Parameter: Nachname, Vorname, Matrikelnummer
    */
   public Student(String name, String vorName, String matrikelNr) {
        this.name = name ;
        this.vorName = vorName ;
        this.matrikelNr = matrikelNr ;
        punkte = 0;
        kurse = new Vector() ;          // Teilaufgabe e)
   }

   // Instanzmethoden
   public String gibName() { return name ; }
   public String gibVorName() { return vorName ; }
   public void nameAendern(String neuerName) { name = neuerName ; }
   public String gibMatrikelNr() { return matrikelNr ; }
   public int gibPunktanzahl() { return punkte ; }

   public void erhoehePunktanzahl(int weiterePunkte) {
      punkte = punkte + weiterePunkte;
   }

   /**
    * Name und Matrikelnummer auf der Konsole aus. 
    */
    public void ausgeben() {
      System.out.println(name + ", " + vorName + " (" + matrikelNr + ")");
   }

   // Teilaufgabe e)
   /**
    * Trage einen Kurs für diesen Teilnehmer ein.
    */
   public void trageKursEin(Laborkurs neuerKurs) {
      kurse.addElement(neuerKurs) ;
   }

   public int anzahlKurse() { return kurse.size() ; }

   // Teilaufgabe e): Lösung mit for-Schleife
   // eleganter: Lösung mit einem Iterator
   /**
    * Gib eine Liste der Kurse aus.
    */
   public void listeAusgeben() {
      int i ;
      ausgeben() ;
      System.out.println("Laborkurse: " + anzahlKurse());

      for (i = 0; i < anzahlKurse(); ++i) {
         Laborkurs aktKurs = (Laborkurs) kurse.elementAt(i) ;
         System.out.print(aktKurs.kursName() + ",  " );
      }
   }

}
